//WinBLAST is a graphical front-end for NCBI BLAST.
//Copyright (C) 2003 Alan Li, alanli@bioinformatics.org
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace WinBLAST
{
	/// <summary>
	/// Summary description for About.
	/// </summary>
	internal class About : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.LinkLabel emailAddress;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.TextBox licenseBox;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.LinkLabel copyrightLabel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		internal About()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			licenseBox.Text =
				"WinBlast is a graphical front-end for NCBI BLAST.\r\n" +
				"Copyright (C) 2004 Alan Li, alanli@bioinformatics.org\r\n\r\n" +
				"This program is free software; you can redistribute it and/or " +
				"modify it under the terms of the GNU General Public License " +
				"as published by the Free Software Foundation; either version 2 " +
				"of the License, or (at your option) any later version.\r\n\r\n" +
				"This program is distributed in the hope that it will be useful, " +
				"but WITHOUT ANY WARRANTY; without even the implied warranty of " +
				"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the " +
				"GNU General Public License for more details.\r\n\r\n" +
				"You should have received a copy of the GNU General Public License " +
				"along with this program; if not, write to the Free Software " +
				"Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(About));
			this.label2 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.emailAddress = new System.Windows.Forms.LinkLabel();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.licenseBox = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.copyrightLabel = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(176, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(136, 24);
			this.label2.TabIndex = 1;
			this.label2.Text = "0.1.5 (20040228)";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(128, 56);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(40, 24);
			this.label5.TabIndex = 4;
			this.label5.Text = "Email:";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// emailAddress
			// 
			this.emailAddress.Location = new System.Drawing.Point(176, 56);
			this.emailAddress.Name = "emailAddress";
			this.emailAddress.Size = new System.Drawing.Size(152, 23);
			this.emailAddress.TabIndex = 5;
			this.emailAddress.TabStop = true;
			this.emailAddress.Text = "alanli@bioinformatics.org";
			this.emailAddress.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.emailAddress.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.emailAddress_LinkClicked);
			// 
			// label3
			// 
			this.label3.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label3.Location = new System.Drawing.Point(128, 32);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 24);
			this.label3.TabIndex = 2;
			this.label3.Text = "Author:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label4.Location = new System.Drawing.Point(176, 32);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 24);
			this.label4.TabIndex = 3;
			this.label4.Text = "Alan Li";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.label1.Location = new System.Drawing.Point(128, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Version:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(164, 314);
			this.pictureBox2.TabIndex = 7;
			this.pictureBox2.TabStop = false;
			// 
			// licenseBox
			// 
			this.licenseBox.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.licenseBox.Location = new System.Drawing.Point(16, 112);
			this.licenseBox.Multiline = true;
			this.licenseBox.Name = "licenseBox";
			this.licenseBox.ReadOnly = true;
			this.licenseBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.licenseBox.Size = new System.Drawing.Size(328, 168);
			this.licenseBox.TabIndex = 8;
			this.licenseBox.Text = "";
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.SystemColors.ActiveBorder;
			this.button1.Location = new System.Drawing.Point(280, 288);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(64, 24);
			this.button1.TabIndex = 9;
			this.button1.Text = "Ok";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// copyrightLabel
			// 
			this.copyrightLabel.LinkColor = System.Drawing.Color.Black;
			this.copyrightLabel.Location = new System.Drawing.Point(128, 88);
			this.copyrightLabel.Name = "copyrightLabel";
			this.copyrightLabel.Size = new System.Drawing.Size(176, 16);
			this.copyrightLabel.TabIndex = 10;
			this.copyrightLabel.TabStop = true;
			this.copyrightLabel.Text = "Copyright (c) 2003-2004 Xyworks";
			this.copyrightLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.copyrightLabel_LinkClicked);
			// 
			// About
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.ClientSize = new System.Drawing.Size(354, 319);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.copyrightLabel,
																		  this.button1,
																		  this.licenseBox,
																		  this.emailAddress,
																		  this.label5,
																		  this.label4,
																		  this.label3,
																		  this.label2,
																		  this.label1,
																		  this.pictureBox2});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Location = new System.Drawing.Point(360, 144);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "About";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "About";
			this.ResumeLayout(false);

		}
		#endregion

		private void emailAddress_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				emailAddress.LinkVisited = true;
				System.Diagnostics.Process.Start( "mailto:alanli@bioinformatics.org" );
			}
			catch( Exception ex )
			{
				// nothing to do here, since we couldn't email.
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void copyrightLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				System.Diagnostics.Process.Start( "http://www.xyworks.com" );
			}
			catch( Exception ex )
			{
				// nothing to do here
			}
		}
	}
}
